<?php  
/*
* cron it, change paths!
* /usr/bin/php -c /etc/php4/apache/php.ini -d memory_limit=128M /var/www/moodleurza/enrol/augdatabase/sync_enrol.php > /var/www/enrol.out
* this takes a while, hourly maybe at 5 min after?
*/

if(!empty($_SERVER['GATEWAY_INTERFACE'])){
    error_log("should not be called from apache!");
    exit;
}

require_once(dirname(dirname(dirname(__FILE__))).'/config.php'); // global moodle config file.
require_once("$CFG->dirroot/enrol/enrol.class.php");

$timenow  = time();
$starttime = microtime();
echo "Server Time: ".date('r',$timenow)."\n\n";

echo "Running enrolment. \n";
        
$select = "$CFG->augdatabase_localuserfield != ' ' and deleted = 0 order by username";
        
if ($students = get_records_select('user', $select)){
	
	foreach ($students as $user) {

    	echo $user->username." = ";
    
   		get_this_student_courses($user);
    
        }
   }

   $timenow  = time();
	echo "\n========================================\n";
	echo "End time: ".date('r',$timenow)."\n";
	$difftime = microtime_diff($starttime, microtime());
    echo "Execution took ".$difftime." seconds"; 

    
    
function get_this_student_courses($user) {
    	global $CFG;

    get_student_courses($user);  /// Start with the list of known enrolments
                                         /// If the database fails we can at least use this
     
         // This is a hack to workaround what seems to be a bug in ADOdb with accessing 
    // two databases of the same kind ... it seems to get confused when trying to access
    // the first database again, after having accessed the second.
    // The following hack will make the database explicit which keeps it happy

    if (strpos($CFG->prefix, $CFG->dbname) === false) {
        $oldprefix = $CFG->prefix;
        $CFG->prefix = "$CFG->dbname.$CFG->prefix";
    }

    // Try to connect to the external database

    $enroldb = &ADONewConnection($CFG->augdatabase_dbtype);

    if ($enroldb->PConnect($CFG->augdatabase_dbhost,$CFG->augdatabase_dbuser,$CFG->augdatabase_dbpass,$CFG->augdatabase_dbname)) {

        $courselist = array();      /// Initialise new array
        $newstudent = array();

        /// Get the authoritative list of enrolments from the database

        $useridnumber = $user->{$CFG->augdatabase_localuserfield};   
		
		echo "[".$useridnumber."] => ";

			/// Union on the two enollment tables

	        if ($rs = $enroldb->Execute("SELECT `$CFG->augdatabase_remotecoursefield` 
                                       FROM `$CFG->augdatabase_dbtable` 
                                      WHERE `$CFG->augdatabase_remoteuserfield` = '$useridnumber' 
                                      UNION
                                      SELECT `$CFG->augdatabase_remoteexceptcoursefield`
                                      FROM `$CFG->augdatabase_remoteexcepttable`
                                      WHERE `$CFG->augdatabase_remoteexceptuserfield` = '$useridnumber'")) {

            if ($rs->RecordCount() > 0) {
                while (!$rs->EOF) {
                    $courselist[] = $rs->fields[0];
                    $rs->MoveNext();
                }

            echo $rs->RecordCount()." courses: ";

                foreach ($courselist as $coursefield) {

 					echo "| ";
 
                     /// look in remote CMS table for the course
                    /// if listed, it will be only once, use that courseid for the moodle one, otherwise stay as it
                	if ($cms = $enroldb->Execute("SELECT `$CFG->augdatabase_remoteconvertcms`
                								  FROM `$CFG->augdatabase_remoteconverttable`
                								  WHERE `$CFG->augdatabase_remoteconvertregistrar` = '$coursefield'")) {
                								  if ($cms->RecordCount() > 0) {
                								  echo "translate ".$coursefield." to ";
                								     $coursefield = $cms->fields[0];
                								  }
                								               								  
                	 }

 
                echo " ".$coursefield." ";

                    if ($course = get_record('course', $CFG->augdatabase_localcoursefield, $coursefield)) {
                        echo "found course mdlid=".$course->id." ";
                        $newstudent[$course->id] = true;             /// Add it to new list
                        if (isset($user->student[$course->id])) {   /// We have it already
                            unset($user->student[$course->id]);       /// Remove from old list
                            echo " already enroled ";
                        } else {
                            enrol_student($user->id, $course->id, 0, 0, 'augdatabase');   /// Enrol the student
                            echo " enrolling in ".$course->id." \n";                            
                        }
                    }
                }
            }

            if (!empty($user->student)) {    /// We have some courses left that we need to unenrol from
                foreach ($user->student as $courseid => $value) {
                echo "I want to unenrol ".$courseid." ";
                // only unenrol if the person was an augdatabase enrolee, auto won't remove a manual enrol
                $selection = "userid = ".$user->id." and course=".$courseid." and enrol = 'augdatabase'";
                if(get_record_select(user_students,$selection)) {
                    echo " unenroling from ".$courseid;
                    unenrol_student($user->id, $courseid);       /// Unenrol the student
                    unset($user->student[$course->id]);           /// Remove from old list
                   }
                
                }
            }

            $user->student = $newstudent;    /// Overwrite the array with the new one
        }
        
        $enroldb->Close();
    }
    
    else { echo "DB connect failed!"; }

    if (!empty($oldprefix)) {
        $CFG->prefix = $oldprefix;           // Restore it just in case
    }

     
    echo "\n"; 
  }

/**
* Returns information about the courses a student has access to
*
* Set the $user->student course array
* Set the $user->timeaccess course array
*
* @param    user  referenced object, must contain $user->id already set
*/
function get_student_courses(&$user) {

    if ($students = get_records("user_students", "userid", $user->id)) {
        $currenttime = time();
        foreach ($students as $student) {

        /// Is course visible?

            if (get_field("course", "visible", "id", $student->course)) {

            /// Is the student enrolment active right now?

                if ( ( $student->timestart == 0 or ( $currenttime > $student->timestart )) and 
                     ( $student->timeend   == 0 or ( $currenttime < $student->timeend )) ) {
                    $user->student[$student->course] = true;
                    $user->timeaccess[$student->course] = $student->timeaccess;
                }
            }
        }
    }   
}



?>
